module Alman
  class DefaultClient < ApiClient

    def initialize(api_key)
      self.refresh_from(api_key)
    end

    def refresh_from(api_key)
      headers = {
        :Accept => "application/json",
        :"Content-Type" => "application/json",
        :Authorization => api_key,
      }
      params = {}
      super(headers, params)
    end

    def calendars
      @calendars ||= CalendarsEndpoint.new(self)
    end

    def vacancies
      @vacancies ||= VacanciesEndpoint.new(self)
    end

    def bookings
      @bookings ||= BookingsEndpoint.new(self)
    end

  end
end
