module Alman
  class BookingsEndpoint < ApiEndpoint

    def new(id)
      Booking.new({:id => id}, nil, @client)
    end

    def retrieve(booking_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :booking_id => booking_id,
      }, params)
      method = ApiMethod.new(:get, "/bookings/:booking_id", params, headers, @parent)
      json = @client.execute(method)
      Booking.new(json, method)
    end

    def delete(booking_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :booking_id => booking_id,
      }, params)
      method = ApiMethod.new(:delete, "/bookings/:booking_id", params, headers, @parent)
      json = @client.execute(method)
      Booking.new(json, method)
    end

    def update(booking_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :booking_id => booking_id,
      }, params)
      method = ApiMethod.new(:put, "/bookings/:booking_id", params, headers, @parent)
      json = @client.execute(method)
      Booking.new(json, method)
    end

  end
end
