module Alman
  class CalendarVacanciesEndpoint < ApiEndpoint

    def all(params={}, headers={})
      method = ApiMethod.new(:get, "/calendars/:id/vacancies", params, headers, @parent)
      json = @client.execute(method)
      ApiList.new(:Vacancy, json, method)
    end

    def all_within(params={}, headers={})
      method = ApiMethod.new(:get, "/calendars/:id/vacancies/within", params, headers, @parent)
      json = @client.execute(method)
      ApiList.new(:Vacancy, json, method)
    end

    def create(params={}, headers={})
      method = ApiMethod.new(:post, "/calendars/:id/vacancies", params, headers, @parent)
      json = @client.execute(method)
      Vacancy.new(json, method)
    end

    def create_range(params={}, headers={})
      method = ApiMethod.new(:post, "/calendars/:id/vacancies/range", params, headers, @parent)
      json = @client.execute(method)
      ApiList.new(:Vacancy, json, method)
    end

    def delete_overlap(params={}, headers={})
      method = ApiMethod.new(:delete, "/calendars/:id/vacancies/overlap", params, headers, @parent)
      json = @client.execute(method)
      ApiList.new(:Vacancy, json, method)
    end

  end
end
