module Alman
  class CalendarsEndpoint < ApiEndpoint

    def new(id)
      Calendar.new({:id => id}, nil, @client)
    end

    def all(params={}, headers={})
      method = ApiMethod.new(:get, "/calendars", params, headers, @parent)
      json = @client.execute(method)
      ApiList.new(:Calendar, json, method)
    end

    def retrieve(calendar_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :calendar_id => calendar_id,
      }, params)
      method = ApiMethod.new(:get, "/calendars/:calendar_id", params, headers, @parent)
      json = @client.execute(method)
      Calendar.new(json, method)
    end

    def delete(calendar_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :calendar_id => calendar_id,
      }, params)
      method = ApiMethod.new(:delete, "/calendars/:calendar_id", params, headers, @parent)
      json = @client.execute(method)
      Calendar.new(json, method)
    end

    def update(calendar_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :calendar_id => calendar_id,
      }, params)
      method = ApiMethod.new(:put, "/calendars/:calendar_id", params, headers, @parent)
      json = @client.execute(method)
      Calendar.new(json, method)
    end

    def create(params={}, headers={})
      method = ApiMethod.new(:post, "/calendars", params, headers, @parent)
      json = @client.execute(method)
      Calendar.new(json, method)
    end

  end
end
