module Alman
  class VacanciesEndpoint < ApiEndpoint

    def new(id)
      Vacancy.new({:id => id}, nil, @client)
    end

    def retrieve(vacancy_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :vacancy_id => vacancy_id,
      }, params)
      method = ApiMethod.new(:get, "/vacancies/:vacancy_id", params, headers, @parent)
      json = @client.execute(method)
      Vacancy.new(json, method)
    end

    def delete(vacancy_id, params={}, headers={})
      params = ParamsBuilder.merge({
        :vacancy_id => vacancy_id,
      }, params)
      method = ApiMethod.new(:delete, "/vacancies/:vacancy_id", params, headers, @parent)
      json = @client.execute(method)
      Vacancy.new(json, method)
    end

  end
end
