module Alman
  class Booking < ApiResource
    attr_accessor :created_at
    attr_accessor :created_at_rfc822
    attr_accessor :end_at
    attr_accessor :end_at_rfc822
    attr_accessor :id
    attr_accessor :meta
    attr_accessor :object
    attr_accessor :start_at
    attr_accessor :start_at_rfc822
    attr_accessor :updated_at
    attr_accessor :updated_at_rfc822

    def self.all(params={}, headers={})
      res = client.bookings.all(params, headers)
      res
    end

    def self.retrieve(booking_id, params={}, headers={})
      res = client.bookings.retrieve(booking_id, params, headers)
      res
    end

    def self.update(booking_id, params={}, headers={})
      res = client.bookings.update(booking_id, params, headers)
      res
    end

    def refresh(params={}, headers={})
      res = client.bookings.retrieve(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    def delete(params={}, headers={})
      res = client.bookings.delete(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    def save(params={}, headers={})
      params = ParamsBuilder.merge(api_attributes, params)
      res = client.bookings.update(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    # Everything below here is used behind the scenes.
    ApiResource.register_api_subclass(self, "booking")
    @api_attributes = {
      :created_at => {},
      :created_at_rfc822 => {},
      :end_at => {},
      :end_at_rfc822 => {},
      :id => {},
      :meta => { :editable => true },
      :object => {},
      :start_at => {},
      :start_at_rfc822 => {},
      :updated_at => {},
      :updated_at_rfc822 => {},
    }
  end
end
