module Alman
  class Calendar < ApiResource
    attr_accessor :created_at
    attr_accessor :created_at_rfc822
    attr_accessor :details
    attr_accessor :id
    attr_accessor :name
    attr_accessor :object
    attr_accessor :updated_at
    attr_accessor :updated_at_rfc822

    def self.all(params={}, headers={})
      res = client.calendars.all(params, headers)
      res
    end

    def self.retrieve(calendar_id, params={}, headers={})
      res = client.calendars.retrieve(calendar_id, params, headers)
      res
    end

    def self.update(calendar_id, params={}, headers={})
      res = client.calendars.update(calendar_id, params, headers)
      res
    end

    def self.create(params={}, headers={})
      res = client.calendars.create(params, headers)
      res
    end

    def refresh(params={}, headers={})
      res = client.calendars.retrieve(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    def delete(params={}, headers={})
      res = client.calendars.delete(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    def vacancies()
      CalendarVacanciesEndpoint.new(client, self)
    end

    def save(params={}, headers={})
      params = ParamsBuilder.merge(api_attributes, params)
      res = client.calendars.update(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    # Everything below here is used behind the scenes.
    ApiResource.register_api_subclass(self, "calendar")
    @api_attributes = {
      :created_at => {},
      :created_at_rfc822 => {},
      :details => { :editable => true },
      :id => {},
      :name => { :editable => true },
      :object => {},
      :updated_at => {},
      :updated_at_rfc822 => {},
    }
  end
end
