module Alman
  class Vacancy < ApiResource
    attr_accessor :created_at
    attr_accessor :created_at_rfc822
    attr_accessor :end_at
    attr_accessor :end_at_rfc822
    attr_accessor :id
    attr_accessor :object
    attr_accessor :start_at
    attr_accessor :start_at_rfc822
    attr_accessor :updated_at
    attr_accessor :updated_at_rfc822

    def self.retrieve(vacancy_id, params={}, headers={})
      res = client.vacancies.retrieve(vacancy_id, params, headers)
      res
    end

    def refresh(params={}, headers={})
      res = client.vacancies.retrieve(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    def delete(params={}, headers={})
      res = client.vacancies.delete(id, params, headers)
      self.refresh_from(res.json, res.api_method, res.client)
    end

    def bookings()
      VacancyBookingsEndpoint.new(client, self)
    end

    # Everything below here is used behind the scenes.
    ApiResource.register_api_subclass(self, "vacancy")
    @api_attributes = {
      :created_at => {},
      :created_at_rfc822 => {},
      :end_at => {},
      :end_at_rfc822 => {},
      :id => {},
      :object => {},
      :start_at => {},
      :start_at_rfc822 => {},
      :updated_at => {},
      :updated_at_rfc822 => {},
    }
  end
end
